import javax.microedition.lcdui.*;

public class morzeForm extends Form implements CommandListener {
 private Lighter Lighter;
 private Display dpy;
 private Displayable prev;
 private options options;

 private Command cmdCancel,cmdOK;
 private TextField inputStr;
 private ChoiceGroup inputCycle;

 public static String letters =
  "ABWGDEVZIJKLMNOPRSTUFHCQYX1234567890,.;:?\"'()!-";
 public static String lowerStr =
  "abwgdevzijklmnoprstufhcqyx1234567890,.;:?\"'()!-";

 public static int [] numbers = {
  0,	1,	2,	3,	4,	5,	6,	7,	8,	9,
  10,	11,	12,	13,	14,	15,	16,	17,	18,	19,
  20,	21,	22,	25,	26,	27,	
  0,	1,	2,	3,	4,	5,	6,	7,	8,	9,
  10,	11,	12,	13,	14,	15,	16,	17,	18,	19,
  20,	21,	22,	23,	24,	25,	26,	27,	28,	29,
  30,	
  31,	32,	33,	34,	35,	36,	37,	38,	39,	40,
  41,	42,	43,	44,	45,	46,	47,	48,	49,	49,	50,
  51
  };

 public static String[] codes={
  ".-",	"-...",	".--",	"--.",	"-..",	".",	"...-",	"--..",	"..",	".---", 	//ABWGDEVZIJ  
  "-.-",	".-..",	"--",	"-.",	"---",	".--.",	".-.",	"...",	"-",	"..-",	//KLMNOPRSTU 
  "..-.","....",	"-.-.",	"---.",	"----",	"--.-",	"-.--",	"-..-",	"..-..","..--",	//FHC  QYX   
  ".-.-",										//
  ".----", "..---", "...--", "....-", ".....", "-....", "--...", "---..", "----.", "-----",   //1234567890
  ".-.-.-","......","-.-.-", "---...","..--..","-..-.", ".-..-.",".----.", "-.--.-","--..--", //,.;:?"' () !
  "-....-"										      //-
 };


 public morzeForm (Lighter Lighter) {
  super(" ");
  this.Lighter = Lighter;
  dpy = Display.getDisplay(Lighter);
  prev = dpy.getCurrent();
  options = new options (false);
  cmdCancel = new Command ("", Command.CANCEL, 0);
  cmdOK = new Command ("OK", Command.OK, 1);
  inputCycle=new ChoiceGroup ("", ChoiceGroup.MULTIPLE);
  inputCycle.append ("  ", null); 
  if (options.morzeCycle!=0) inputCycle.setSelectedIndex (0,true);
  else inputCycle.setSelectedIndex (0,false);
  String s;
  if (LighterCanvas.morzeStr.length()>0) s=LighterCanvas.morzeStr;
  else s="";
  inputStr=new TextField ("",s,16,TextField.ANY);
  append (inputCycle); append (inputStr);
  addCommand(cmdCancel); addCommand(cmdOK);
  setCommandListener(this);
 }

 public void commandAction(Command c, Displayable d) {
  int r,g,b,c1;
  if (c == cmdCancel) {
   dpy.setCurrent(prev);
  }
  else if (c==cmdOK) {
   boolean w1=inputCycle.isSelected(0);
   if (w1==true) options.morzeCycle=1;
   else options.morzeCycle=0;
   LighterCanvas.morzeStr=deleteDoubleSpaces(inputStr.getString().trim());
   LighterCanvas.dashStr=getCode(LighterCanvas.morzeStr);
   LighterCanvas.nextSymbol=0;
   dpy.setCurrent(prev);
  }
 }

 public String getCode (String in) {
  //0-    , 1 -  , 2 -  
  String code="";
  in=toUpperCase(in);
  for (int i=0; i<in.length(); i++) {
   int c=(int)(in.charAt (i));
   if (c==' ') {
    code+='2';
   }
   else {
    int k=letters.indexOf(c);
    if (k==-1) { // 
    }
    else {
     String s=codes[numbers[k]];
     for (int j=0; j<s.length(); j++) {
      code+=s.charAt(j);
      if (j<s.length()-1) code+='0';
     }
     if ( (i<in.length()-1) && (in.charAt(i+1)!=' ')) code+='1';
    }
   }
  }
  code+='2';
  //System.out.println (code);//!!!
  return code;
 }

 public String toUpperCase(String in) {
  String out="";
  char c; 
  int n;
  for (int i=0; i<in.length(); i++) {
   c=in.charAt (i);
   n=lowerStr.indexOf(c);
   if (n>-1) out+=letters.charAt(n);
   else out+=c;
  }
  return out;
 }

 public String deleteDoubleSpaces (String in) {
  String out=in;
  int p;
  do {
   p=out.indexOf("  ");
   if (p>-1) out=out.substring (0,p)+out.substring(p+1);
  } while (p>-1);
  return out;
 }

}