import javax.microedition.midlet.MIDlet;
import javax.microedition.lcdui.*;
import java.util.Timer;

public class Lighter extends MIDlet {
 public int timerInterval=1000;
 private Display display;
 public Timer timer=null;
 public LighterTimerTask timertask=null;
 private LighterCanvas canvas;
 private options options;

 public Lighter() {
  display = Display.getDisplay(this);
  if (display.isColor()==false) {
   Alert error=new Alert("Error","You need color phone to run this MIDlet!",null,AlertType.ERROR);
   error.setTimeout(2000);
   exitMIDlet();
  }
  options = new options (true); //  
  options.read ();
  canvas  = new LighterCanvas(this);
  animateTo (timerInterval);
 }
 
 protected void startApp() {
  display.setCurrent(canvas);
 }
 
 protected void pauseApp()  { }

 protected void destroyApp (boolean unconditional)  { 
  cancelTo();
  options.write ();
  options.close ();
 }

 public void animateTo (long delay) {
  if (timer == null) timer = new Timer();
  if (timertask != null) {
   timertask.cancel();
   timertask = null;
  }
  timertask = new LighterTimerTask (canvas);
  timer.schedule (timertask, (long)delay);
 }

 public void cancelTo() {
  if (timertask != null) {
   timertask.cancel();
   timertask = null;
  }
  if (timer != null) {
   timer.cancel();
   timer = null;
  }
 }
 
 public void exitMIDlet()  {
  destroyApp(true);
  notifyDestroyed();
 }
}

