import javax.microedition.lcdui.*;

public class colorForm extends Form implements CommandListener {
 private Lighter Lighter;
 private Display dpy;
 private Displayable prev;
 private errorForm er;

 private Command cmdCancel,cmdOK;
 private TextField inputR,inputG,inputB;

 public int getRed (int color) {
  return (color & 0xFF0000) >> 16;
 }

 public int getGreen (int color) {
  return (color & 0x00FF00) >> 8;
 }

 public int getBlue (int color) {
  return (color & 0x0000FF);
 }

 public int getColor (int r, int g, int b) {
  return ((r<<16) | (g<<8) | (b));
 }

 public void setColor (int color) {
  options options = new options (false);
  switch (LighterCanvas.mode) {
   case LighterCanvas.MODE_CANVAS:
    options.color1=color;
   break;
   case LighterCanvas.MODE_COLOR1:
    options.gColor1=color;
   break;
   case LighterCanvas.MODE_COLOR2:
    options.gColor2=color;
   break;
  }
 }

 public colorForm (Lighter Lighter, String hdr, int color) {
  super(hdr);
  this.Lighter = Lighter;
  dpy = Display.getDisplay(Lighter);
  prev = dpy.getCurrent();
  cmdCancel = new Command ("", Command.CANCEL, 0);
  cmdOK = new Command ("OK", Command.OK, 1);
  inputR=new TextField ("  (0-255):",""+getRed(color),3,TextField.NUMERIC);
  inputG=new TextField ("  (0-255):",""+getGreen(color),3,TextField.NUMERIC);
  inputB=new TextField ("  (0-255):",""+getBlue(color),3,TextField.NUMERIC);
  append (inputR); append (inputG); append (inputB);
  addCommand(cmdCancel); addCommand(cmdOK);
  setCommandListener(this);
 }

 public void commandAction(Command c, Displayable d) {
  int r,g,b,c1;
  er = new errorForm (dpy,"");
  if (c == cmdCancel) {
   dpy.setCurrent(prev);
  }
  else if (c==cmdOK) {
   r=Integer.parseInt(inputR.getString().trim());
   g=Integer.parseInt(inputG.getString().trim());
   b=Integer.parseInt(inputB.getString().trim());
   if ((r<0) || (r>255) || (g<0) || (g>255) || (b<0) || (b>255)) {
    er.show ("    0  255!");
   }
   else {
    c1=getColor (r,g,b);
    setColor (c1);
    dpy.setCurrent(prev);
   }
  }
 }

}